	;ShowPort - Shows status of the two lines on the link port
	;Copyright 1997 Shawn D'Alimonte
	;This program is Freeware
	;It may be distributed as long as no charge is made other than a 
	;reasonable charge for disks, etc.
	;If you make changes to this program please give me some credit
	;and clearly indicate what you changed.

	;Questions/comments? 
	;Email: aa600@torfree.net  or sdalimon@ee.ryerson.ca
	; I also read the calc-ti newsgroup/mailing list

	;Yes I know the code is messy, but it is my first non-trivial
	;assembly program and if you notice my assembler did not have a 
	;macro feature and my String85 doesn't add the $00FD ZShell looks 
	;for at the start of the program.

	;Known problems:
	;-There has to be a better way to display lots of text....

	
	;Note to PC users
	;To use with TASM you will likely have to make some changes
	;- The PC String85 adds the $00FD for you, right?
	;- I don't think TASM uses STRING to include ASCII
	;- Code would look neater using TASMS macros and the origional 
	;  ti-85.h file ie: ROM_CALL(CLEARLCD) instead of 
	;  call ROM_CALL/db CLEARLCD

	incl	"ti-85.h"	;TI 85 include file

	db	00		;ZShell signature 
	db	$fd

	db	5		;Description length

	org 0			;I think this is in right place.  Seems to work

	string	"ShPrt"		;ZShell Description
	db	0

	call	ROM_CALL
	db	CLEARTEXT	;Sorry assembler doesn't do macros

	ld	A,1		;Indicator labels
	ld	(CURSOR_X),A
	ld	A,2
	ld	(CURSOR_Y),A
	ld	HL,(PROGRAM_ADDR)
	ld	DE,lbltx
	add	HL,DE
	call	ROM_CALL
	db	D_ZT_STR

	ld	A,1			;Display the info text
	ld	(CURSOR_X),A		;There has to be an easier way to
	ld	A,2*8			;do this!?!?!?! :-(
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro1tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR

	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro2tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR

	ld	A,1
	ld	(CURSOR_X),A
	ld	A,2*8+2*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro3tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR

	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+3*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro4tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR
	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+3*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro4tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR
	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+3*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro4tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR

	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+3*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro4tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR

	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+4*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro5tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR

	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+5*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro6tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR

	ld	A,1		
	ld	(CURSOR_X),A
	ld	A,2*8+6*6
	ld	(CURSOR_Y),A
	ld	HL, (PROGRAM_ADDR)
	ld	DE, intro7tx
	add	HL,DE
	call	ROM_CALL
	db	D_ZM_STR	;FINALLY DONE THAT!

	ld 	IX, VIDEO_MEM	;Start of video RAM
loop	in	A,(7)		;Read comm port
	bit	0,A		;Bit 0 (TIP) set?
	jr	Z,skipa		
	ld	(IX+2),$FF	;Turn on indicator
	jr	skip2
skipa	ld	(IX+2),$0000	;Turn off indicator
skip2	bit	1,A		;Bit 1 (RING) set?
	jr	Z,skipb
	ld	(IX+0),$FF	;Turn on indicator
	jr	skip4
skipb	ld	(IX+0), $0000	;Turn off indicator
skip4	
	call	GET_KEY		;Check for keypress
	cp	$37		;Exit?
	jr	nz,loop		;No?  then loop back
	ret			;Get back to ZShell

;Message strings.

lbltx	string	"R  T"
	db	0
intro1tx	string	"ShowPort by Shawn D'Alimonte"
		db	0
intro2tx	string	"email: aa600@torfree.net"
		db	0
intro3tx	string	"Copyright (C)1997 Shawn D'Alimonte"
		db	0
intro4tx	string	"This program is Freeware!!!!!!!!!"
		db	0
intro5tx	string	"Bars above letters indicate status of"
		db	0
intro6tx	string	"that port connector"
		db	0
intro7tx	string	"Press [EXIT] when done"
		db	0
